#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>

#include "..\devicen.h"

HANDLE	hVxD, hDev1, hDev2;
const PCHAR VxDName =  "\\\\.\\_DEVICEN";
const PCHAR Dev1Name = "\\\\.\\DEVICE1";
const PCHAR Dev2Name = "\\\\.\\DEVICE2";
 
DWORD OpenDevice( PCHAR name, HANDLE *pDeviceHandle)
{
   HANDLE   hnd;
   DWORD    err;


   hnd = CreateFile(name, 0,0,0, 
              CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, 0);

   if (hnd == INVALID_HANDLE_VALUE) 
      {                                
      err = GetLastError();         
      if (err == ERROR_NOT_SUPPORTED) 
      {                                
         DeleteFile(name);             
      }                                
   }                                  
   else
   {
      err = 0;
      *pDeviceHandle = hnd;
   }

   return err;
}                                                     


void main(int ac, char* av[])
{
   DWORD    cbBytesReturned;
   DWORD    err;
   DWORD    func;
   DWORD    NumDevices;
   CHAR     abDeviceName[8];

                                 
   if (err = OpenDevice(Dev1Name, &hDev1))
   {
      fprintf(stderr, "Cannot open %s, error=%08lx\n", 
               Dev1Name, err );
   }

   memset( abDeviceName, ' ', sizeof(abDeviceName) );
   func = DIOC_DEVICEN_GETDEVICENAME;
   if (!DeviceIoControl(hDev1, func,
                        NULL, 0,  
                        abDeviceName, sizeof(abDeviceName), 
                        &cbBytesReturned, NULL))
   {
      fprintf(stderr, "DevIoCtl func %x failed, error %x\n", 
             func, GetLastError() );
   }
   printf("DevIoCtl Name=%c%c%c%c%c%c%c%c\n",
            abDeviceName[0], abDeviceName[1], 
            abDeviceName[2], abDeviceName[3], 
            abDeviceName[4], abDeviceName[5], 
            abDeviceName[6], abDeviceName[7] );

   if (err = OpenDevice(Dev2Name, &hDev2))
   {
      fprintf(stderr, "Cannot open %s, error=%08lx\n", 
               Dev2Name, err );
   }

   memset( abDeviceName, ' ', sizeof(abDeviceName) );
   func = DIOC_DEVICEN_GETDEVICENAME;
   if (!DeviceIoControl(hDev2, func,
                        NULL, 0,  
                        abDeviceName, sizeof(abDeviceName), 
                        &cbBytesReturned, NULL))
   {
      fprintf(stderr,"DevIoCtl func %x failed, error %x\n", 
            func, GetLastError() );
   }
   printf("DevIoCtl Name=%c%c%c%c%c%c%c%c\n",
            abDeviceName[0], abDeviceName[1], 
            abDeviceName[2], abDeviceName[3], 
            abDeviceName[4], abDeviceName[5], 
            abDeviceName[6], abDeviceName[7] );

   if (err = OpenDevice(VxDName, &hVxD))
   {
      fprintf(stderr, "Cannot open %s, error=%08lx\n", 
               VxDName, err );
   }

   func = DIOC_DEVICEN_GETNUMDEVICES;
   if (!DeviceIoControl(hVxD, func, 
                        NULL, 0,  
                        &NumDevices, sizeof(NumDevices), 
                        &cbBytesReturned, NULL))
   {
      fprintf(stderr, "DevIoCtl func %x failed, error %x\n", 
             func, GetLastError() );
   }
   printf("DevIoCtl NumDevices=%d\n", func, NumDevices );


   CloseHandle( hVxD );
   CloseHandle( hDev1 );
   CloseHandle( hDev2 );
}
